;
; coded by vinoca
; site: hi.baidu.com/bywei

format PE console
entry start

  VERSION   equ '1.0.0.2'

include 'win32ax.inc'

;sturct and const define ;{{{


  CSIDL_DESKTOP				= 0x0000
  CSIDL_INTERNET				= 0x0001
  CSIDL_PROGRAMS				= 0x0002
  CSIDL_CONTROLS				= 0x0003
  CSIDL_PRINTERS				= 0x0004
  CSIDL_PERSONAL				= 0x0005
  CSIDL_FAVORITES				= 0x0006
  CSIDL_STARTUP				= 0x0007
  CSIDL_RECENT				= 0x0008
  CSIDL_SENDTO				= 0x0009
  CSIDL_BITBUCKET				= 0x000a
  CSIDL_STARTMENU				= 0x000b
  CSIDL_DESKTOPDIRECTORY            = 0x0010
  CSIDL_DRIVES				= 0x0011
  CSIDL_NETWORK				= 0x0012
  CSIDL_NETHOOD				= 0x0013
  CSIDL_FONTS				= 0x0014
  CSIDL_TEMPLATES				= 0x0015
  CSIDL_COMMON_STARTMENU	      = 0x0016
  ;CSIDL_COMMON_PROGRAMS		      = 0X0017
  CSIDL_COMMON_STARTUP		      = 0x0018
  CSIDL_COMMON_DESKTOPDIRECTORY     = 0x0019
  CSIDL_APPDATA				= 0x001a
  CSIDL_PRINTHOOD				= 0x001b
  CSIDL_ALTSTARTUP		      = 0x001d ; DBCS
  CSIDL_COMMON_ALTSTARTUP	      = 0x001e ; DBCS
  CSIDL_COMMON_FAVORITES	      = 0x001f
  CSIDL_INTERNET_CACHE		      = 0x0020
  CSIDL_COOKIES				= 0x0021
  CSIDL_HISTORY				= 0x0022


struc GUID def
 {
   match d1-d2-d3-d4-d5, def
    \{
      .Data1 dd 0x\#d1
      .Data2 dw 0x\#d2
      .Data3 dw 0x\#d3
      .Data4 db 0x\#d4 shr 8,0x\#d4 and 0FFh
      .Data5 db 0x\#d5 shr 40,0x\#d5 shr 32 and 0FFh,0x\#d5 shr 24 and 0FFh,0x\#d5 shr 16 and 0FFh,0x\#d5 shr 8 and 0FFh,0x\#d5 and 0FFh
    \}
 }

interface IShellLink,\
      QueryInterface,\
      AddRef,\
      Release,\
	GetPath,\
	GetIDList,\
	SetIDList,\
	GetDescription,\
	SetDescription,\
	GetWorkingDirectory,\
	SetWorkingDirectory,\
	GetArguments,\
	SetArguments,\
	GetHotkey,\
	SetHotkey,\
	GetShowCmd,\
	SetShowCmd,\
	GetIconLocation,\
	SetIconLocation,\
	SetRelativePath,\
	Resolve,\
	SetPath

interface IPersistFile,\
       QueryInterface       ,\
       AddRef               ,\
       Release              ,\
       GetClassID           ,\
       IsDirty              ,\
       Load                 ,\
       Save                 ,\
       SaveCompleted        ,\
       GetCurFile           

CLSCTX_INPROC_SERVER	    = 0x1
CLSCTX_INPROC_HANDLER	    = 0x2
CLSCTX_LOCAL_SERVER	    = 0x4
CLSCTX_INPROC_SERVER16	    = 0x8
CLSCTX_REMOTE_SERVER	    = 0x10
CLSCTX_INPROC_HANDLER16     = 0x20
CLSCTX_INPROC_SERVERX86     = 0x40
CLSCTX_INPROC_HANDLERX86    = 0x80
CLSCTX_ESERVER_HANDLER	    = 0x100
CLSCTX_NO_CODE_DOWNLOAD     = 0x400
CLSCTX_NO_CUSTOM_MARSHAL    = 0x1000
CLSCTX_ENABLE_CODE_DOWNLOAD = 0x2000
CLSCTX_NO_FAILURE_LOG	    = 0x4000
CLSCTX_DISABLE_AAA	    = 0x8000
CLSCTX_ENABLE_AAA	    = 0x10000
CLSCTX_FROM_DEFAULT_CONTEXT = 0x20000

 CLSID_ShellLink GUID 00021401-0000-0000-C000-000000000046
 IID_IShellLink GUID 000214EE-0000-0000-C000-000000000046
 IID_IPersistFile GUID 0000010B-0000-0000-C000-000000000046
                                                                              ;}}}

proc start
locals
  rarg            rd 1
  sho_opt_flag    rb 1
endl
      invoke      GetCommandLine
      mov   [rarg],eax
      call  argc
      cmp   eax,1
      jle   showhelp
      cmp   eax,2
      je    errarg
      cmp   eax,9
      ja    errarg
      mov   ebx,eax
	invoke	CoInitialize,NULL
	invoke	CoCreateInstance,CLSID_ShellLink,NULL,CLSCTX_INPROC_SERVER,IID_IShellLink,shll
      test  eax,eax
      jnz   exitapp
	cominvk     shll,QueryInterface,IID_IPersistFile,pf
      test  eax,eax
      jnz   exitapp
      stdcall     argv,[rarg],2,buff1
      cmp   dword[eax],'sho'
      jne   @f
      mov   [sho_opt_flag],1
      jmp   .end_sethk
    @@:
      mov   esi,eax
	cominvk     shll,SetPath,eax
      test  eax,eax
      jnz   errtar
      invoke      lstrlen,esi
      mov   ecx,esi
      add   esi,eax
    @@:
      dec   esi
      mov   al,[esi]
      test  al,al
      jz    @f
      cmp   al,'\'
      jnz   @b
      mov   byte[esi],0
      cominvk     shll,SetWorkingDirectory,ecx
      test  eax,eax
      jnz   errtar
    @@:
      cmp   ebx,7
      jl    .end_showcmd
      stdcall     argv,[rarg],6,buff1
      cmp   byte[eax],0
      jz   .end_showcmd
      mov   esi,eax
      push  eax
      xor   ecx,ecx
    @@:
      mov   al,[esi]
      inc   esi
      inc   ecx
      test  al,al
      jnz    @b
      cmp   ecx,4
      jne   errshowcmd
      pop   esi
      and   dword[esi],not 00202020h
      mov   eax,[esi]
      .if     eax='NOR'
        mov eax,1
      .elseif eax='MAX'
        mov eax,3
      .elseif eax='MIN'
        mov eax,7
      .else
        jmp errshowcmd
      .endif
	cominvk     shll,SetShowCmd,eax
      test  eax,eax
      jnz   errshowcmd
    .end_showcmd:
      cmp   ebx,8
      jl    .end_sethk
      stdcall     argv,[rarg],7,buff1
      cmp  byte[eax],0
      jz    .end_sethk
      mov   esi,eax
      mov   edx,eax
      push  esi
      xor   edi,edi
    @@:
      mov   al,[esi]
      inc   esi
      inc   edi
      test  al,al
      jz    @f
      cmp   al,'|'
      jne   @b
    @@:
      xor   ecx,ecx
      pop   esi
      cmp   al,'|'
      jne   .no_bar
    @@:
      dec   edi
      test  edi,edi
      jz    @f
      mov   al,[esi]
      inc   esi
      and   al,not 20h
      .if al='A'
        add ecx,4
      .elseif al='C'
        add ecx,2
      .elseif al='E'
        add ecx,8
      .elseif al='S'
        add ecx,1
      .else
        pop eax
        jmp errhk
      .endif
      jmp   @b
    @@:      
      mov   edx,ecx
      inc   esi 
    .no_bar:
      push  ebx
      call      ascii_to_dword
      pop   ebx
      xor   eax,eax
      mov   eax,edx
      shl   ax,8
      mov   al,cl
      cominvk     shll,SetHotkey,eax
      test  eax,eax
      jnz   errhk

    .end_sethk:
    @@:
      cmp   ebx,5
      je    errarg
      cmp   ebx,6
      jl    @f
      stdcall     argv,[rarg],4,buff1
      add   eax,260
      stdcall     argv,[rarg],5,eax
      mov   esi,eax
      push  ebx
      call  ascii_to_dword
      pop   ebx
	cominvk     shll,SetIconLocation,buff1,ecx
      test  eax,eax
      jnz   errico
    @@:
      cmp   ebx,4
      jl    @f
      stdcall     argv,[rarg],3,buff1
      test  al,al
      jz    @f
	cominvk     shll,SetArguments,eax 
    @@:
      cmp   ebx,9
      jl    @f
      stdcall     argv,[rarg],8,buff1
      cominvk     shll,SetDescription,eax
    @@:
      stdcall     argv,[rarg],1,buff1
      mov   esi,eax
      mov   ecx,eax
      cld
    @@:      
      mov   al,[esi]
      inc   esi
      test  al,al
      jz    .no_var
      cmp   al,'$'
      jne   @b
      push  esi
    @@:
      .if byte[esi]=0
        mov [sho_opt_flag],2
        jmp @f
      .endif
      and   byte[esi],not 20h
      inc   esi
      cmp   byte[esi],'\'
      jne   @b
      mov   byte[esi],0
    @@:
      pop   eax
      inc   esi
      push  esi
      mov   esi,eax
      mov   edx,esi
      mov   ebx,str_compare
      mov   edi,upper_desktop
      call  ebx
      jne   @f
      mov   eax,CSIDL_DESKTOP
      jmp   .get_sys_var
    @@:
      mov   esi,edx
      mov   edi,upper_quicklaunch
      call  ebx
      jne   @f
      mov   eax,CSIDL_APPDATA
      jmp   .get_sys_var
    @@:
      mov   esi,edx
      mov   edi,upper_sendto
      call  ebx
      jne   @f
      mov   eax,CSIDL_SENDTO
      jmp   .get_sys_var
    @@:
      mov   esi,edx
      mov   edi,upper_startmenu
      call  ebx
      jne   @f
      mov   eax,CSIDL_STARTMENU
      jmp   .get_sys_var
    @@:
      mov   esi,edx
      mov   edi,upper_smprograms
      call  ebx
      jne   @f
      mov   eax,CSIDL_PROGRAMS
      jmp   .get_sys_var
    @@:
      mov   esi,edx
      mov   edi,upper_templates
      call  ebx
      jne   @f
      mov   eax,CSIDL_TEMPLATES
      jmp   .get_sys_var
    @@:
      pop   eax
      stdcall     argv,[rarg],1,buff1
      mov   ecx,eax
      jmp   .no_var

    .get_sys_var:
      mov   ebx,eax
      mov   edi,buff_dword
      invoke      SHGetMalloc,edi
      invoke      SHGetSpecialFolderLocation,0,ebx,edi
      mov   esi,buff1
      add   esi,MAX_PATH
      invoke      SHGetPathFromIDList,dword[edi],esi
      cmp   ebx,CSIDL_APPDATA
      jne   @f
      invoke      lstrcat,esi,quick_launch
    @@:
      pop   edi
      cmp   [sho_opt_flag],2
      je    show_realname
      mov   byte[edi-1],'\'
      dec   edi
      invoke      lstrcat,esi,edi
      mov   ecx,esi
    .no_var:
      mov   esi,ecx
    @@:
      mov   al,[esi]
      inc   esi
      test  al,al
      jnz   @b
      mov   eax,[esi-5]
      and   eax,not 20202000h
      cmp   eax,'.LNK'
      je    @f
      mov   dword[esi-1],'.lnk'
      mov   byte[esi+3],0
    @@:
      mov   esi,ecx
      cmp   [sho_opt_flag],1
      je    show_realname
      mov   ebx,buff1
      add   ebx,512
      invoke      MultiByteToWideChar,CP_ACP,0,ecx,-1,ebx,MAX_PATH
      cominvk     pf,Save,ebx,TRUE
      test  eax,eax
      jnz   errsou
      jmp   exitapp

    show_realname:
      cinvoke     printf,esi
      jmp   exitapp

    errarg:
      cinvoke     printf,invalid_arg
      jmp   exitapp
    errsou:
      cinvoke     printf,invalid_shortcut_name
      jmp   exitapp
    errtar:
      cinvoke     printf,invalid_target_name
      jmp   exitapp
    errico:
      cinvoke     printf,invalid_icon_arg
      jmp   exitapp
    errshowcmd:
      cinvoke     printf,invalid_start_opt
      jmp   exitapp
    errhk:
      cinvoke     printf,invalid_hotkey
      jmp   exitapp
    showhelp:
      cinvoke     printf,help

    exitapp:
      cmp   [pf],0
      jz    @f
      cominvk     pf,Release
      cominvk     shll,Release
      invoke      CoUninitialize
    @@:
	invoke	ExitProcess,0
endp

include 'vilib/proc.asm'

data import ;{{{
  library kernel32,'KERNEL32.DLL',\
	  user32,'USER32.DLL',\
        shell32,'shell32.dll',\
        msvcrt,'msvcrt.dll',\
	  ole,'OLE32.DLL'

include 'api/kernel32.inc'
include 'api/user32.inc'

  import shell32,\
      SHGetMalloc,'SHGetMalloc',\
      SHGetPathFromIDList,'SHGetPathFromIDListA',\
      SHGetSpecialFolderLocation,'SHGetSpecialFolderLocation'

  import msvcrt,\
      printf,'printf'

  import ole,\
      CoInitialize,'CoInitialize',\
      CoUninitialize,'CoUninitialize',\
      CoCreateInstance,'CoCreateInstance'
end data    ;}}}
       
;variable   define      {{{
 help       db 13,10,'shortcut,creat a shortcut for windows shell.',9,'version: ',VERSION,13,10,13,10,\
            'Usage:',13,10,\
            'shortcut .lnk_file target_file [parameters] [icon_file icon_index]',\
            '[start_options] [hotkey] [description]',13,10,13,10,\
            'Examples:',13,10,\
            'shortcut $quicklaunch\demo.lnk C:',13,10,\
            'shortcut $desktop\demo C: "" "C:\WINDOWS\explorer.exe" 5 nor "ca|8" demo',\
            13,10,13,10,\
            'Following variable can be used in shortcut file name:',13,10,\
            '$desktop $quicklaunch $sendto $startmenu $smprograms $templates',13,10,13,10,\
            'start_options should be one of: nor max min',13,10,\
            'hotkey use "[modifier flags|]Virtual-Key Codes" format,modifier flags can be a combination ',\
            'of c(CONTROL key) a(ALT key) s(SHIFT key) e(Extended key),and codes is decimal system',13,10,\
            13,10,'Use shortcut <name> sho to SHOW the name,such as "shortcut $desktop sho"',13,10,\
            13,10,'Type "-h" to show this help',9, '  site: hi.baidu.com/bywei',13,10,0

 invalid_arg            db 'Invalid arguments.',13,10,0
 invalid_target_name    db 'Invalid target name.',13,10,0
 invalid_shortcut_name  db 'Invalid shortcut file name.',13,10,0
 invalid_icon_arg       db 'Invalid icon arguments.',13,10,0
 invalid_start_opt      db 'Invalid start_options.',13,10,0
 invalid_hotkey         db 'Invalid hotkey.',13,10,0

  quick_launch          db '\Microsoft\Internet Explorer\Quick Launch',0

  upper_desktop         db 'DESKTOP',0
  upper_quicklaunch     db 'QUICKLAUNCH',0
  upper_sendto          db 'SENDTO',0
  upper_startmenu       db 'STARTMENU',0
  upper_smprograms      db 'SMPROGRAMS',0
  upper_templates       db 'TEMPLATES',0
      
align 16

  shll                  IShellLink
  pf                    IPersistFile
  buff_dword            rd 1
  buff1                 rb 1024

            ;}}}

section '.rsrc' resource data readable ;{{{

  directory RT_VERSION,versions

  resource versions,\
	   1,LANG_NEUTRAL,version
  
  versioninfo version,VOS__WINDOWS32,VFT_APP,VFT2_UNKNOWN,LANG_ENGLISH+SUBLANG_DEFAULT,0,\
	      'FileDescription','shortcut,creat a shortcut for windows shell.',\
            'WWW','hi.baidu.com/bywei',\
	      'LegalCopyright','No rights reserved.',\
	      'CompanyName', 'coded by vinoca.',\
	      'FileVersion',VERSION,\
	      'OriginalFilename','shortcut.exe'
            ;}}}

; vim: set fdm=marker:
